#include <stdio.h>
#include <dlfcn.h>
#include "test.h"

void test2(int);

int
main(int ac, char *av[])
{
	void *h;
	void *h_libbar;
	char (*fn)(void);
	int mode;

	mode = 0;
	if (ac > 1)
		mode = atoi(av[1]);
	if (mode < 0 || mode > 2)
		mode = 0;

	/*
	 * 0 = don't do a pre load/unload at all.
	 * 1 = do a RTLD_LOCAL preload/unload
	 * 2 = do a RTLD_GLOBAL preload/unload
	 */
	if (mode > 0) {
		printf("====== initial run\n");
		if (mode > 1) {
			h = dlopen("xyz.so", RTLD_GLOBAL | RTLD_NOW);
			printf("RTLD_GLOBAL xyz.so: handle %s\n", h ? "ok" : "NULL");
		} else {
			h = dlopen("xyz.so", RTLD_LOCAL | RTLD_NOW);
			printf("RTLD_LOCAL xyz.so: handle %s\n", h ? "ok" : "NULL");
		}
		fn = dlsym(h, "xyz");
		if (fn) { printf("with h (xyz):\n"); fn(); } else { printf("with h (xyz): NULL\n"); }
		fn = dlsym(h, "bar");
		if (fn) { printf("with h (bar):\n"); fn(); } else { printf("with h (bar): NULL\n"); }
		fn = dlsym(RTLD_DEFAULT, "xyz");
		if (fn) { printf("DEFAULT (xyz):\n"); fn(); } else { printf("DEFAULT (xyz): NULL\n"); }
		fn = dlsym(RTLD_DEFAULT, "bar");
		if (fn) { printf("DEFAULT (bar):\n"); fn(); } else { printf("DEFAULT (bar): NULL\n"); }
		dlclose(h);
	}

	printf("==== now openeing libbar.so first\n");

	h_libbar = dlopen("libbar.so", RTLD_GLOBAL | RTLD_NOW);
	printf("RTLD_GLOBAL libbar.so: handle %s\n", h_libbar ? "ok" : "NULL");
	
	h = dlopen("xyz.so", RTLD_GLOBAL | RTLD_NOW);
	printf("RTLD_GLOBAL xyz.so: handle %s\n", h ? "ok" : "NULL");

	fn = dlsym(h, "xyz");
	if (fn) { printf("with h (xyz):\n"); fn(); } else { printf("with h (xyz): NULL\n"); }
	fn = dlsym(h, "bar");
	if (fn) { printf("with h (bar):\n"); fn(); } else { printf("with h (bar): NULL\n"); }
	fn = dlsym(RTLD_DEFAULT, "xyz");
	if (fn) { printf("DEFAULT (xyz):\n"); fn(); } else { printf("DEFAULT (xyz): NULL\n"); }
	fn = dlsym(RTLD_DEFAULT, "bar");
	if (fn) { printf("DEFAULT (bar):\n"); fn(); } else { printf("DEFAULT (bar): NULL\n"); }

	dlclose(h_libbar); printf("now with libbar.so dlclosed\n");

	fn = dlsym(h, "xyz");
	if (fn) { printf("with h (xyz):\n"); fn(); } else { printf("with h (xyz): NULL\n"); }
	fn = dlsym(h, "bar");
	if (fn) { printf("with h (bar):\n"); fn(); } else { printf("with h (bar): NULL\n"); }
	fn = dlsym(RTLD_DEFAULT, "xyz");
	if (fn) { printf("DEFAULT (xyz):\n"); fn(); } else { printf("DEFAULT (xyz): NULL\n"); }
	fn = dlsym(RTLD_DEFAULT, "bar");
	if (fn) { printf("DEFAULT (bar):\n"); fn(); } else { printf("DEFAULT (bar): NULL\n"); }

	dlclose(h);

	printf("======== starting again\n");

	h = dlopen("xyz.so", RTLD_GLOBAL | RTLD_NOW);
	printf("RTLD_GLOBAL xyz.so: handle %s\n", h ? "ok" : "NULL");
	fn = dlsym(h, "xyz");
	if (fn) { printf("with h (xyz):\n"); fn(); } else { printf("with h (xyz): NULL\n"); }
	fn = dlsym(h, "bar");
	if (fn) { printf("with h (bar):\n"); fn(); } else { printf("with h (bar): NULL\n"); }
	fn = dlsym(RTLD_DEFAULT, "xyz");
	if (fn) { printf("DEFAULT (xyz):\n"); fn(); } else { printf("DEFAULT (xyz): NULL\n"); }
	fn = dlsym(RTLD_DEFAULT, "bar");
	if (fn) { printf("DEFAULT (bar):\n"); fn(); } else { printf("DEFAULT (bar): NULL\n"); }

	dlclose(h);
}
